'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Rotation = function (_Component) {
  _inherits(Rotation, _Component);

  function Rotation(props) {
    _classCallCheck(this, Rotation);

    var _this = _possibleConstructorReturn(this, (Rotation.__proto__ || Object.getPrototypeOf(Rotation)).call(this, props));

    _this.state = { current: 0 };

    _this.handleWheel = _this.handleWheel.bind(_this);
    _this.handleTouchStart = _this.handleTouchStart.bind(_this);
    _this.handleTouchMove = _this.handleTouchMove.bind(_this);
    _this.handleTouchEnd = _this.handleTouchEnd.bind(_this);
    return _this;
  }

  _createClass(Rotation, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var el = (0, _reactDom.findDOMNode)(this);
      if (this.props.scroll) el.addEventListener('wheel', this.handleWheel, false);
      el.addEventListener('touchstart', this.handleTouchStart, false);
      el.addEventListener('touchmove', this.handleTouchMove, false);
      el.addEventListener('touchend', this.handleTouchEnd, false);
      el.addEventListener('mousedown', this.handleTouchStart, false);
      el.addEventListener('mousemove', this.handleTouchMove, false);
      document.addEventListener('mouseup', this.handleTouchEnd, false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var el = (0, _reactDom.findDOMNode)(this);
      if (this.props.scroll) el.removeEventListener('wheel', this.handleWheel, false);
      el.removeEventListener('touchstart', this.handleTouchStart, false);
      el.removeEventListener('touchmove', this.handleTouchMove, false);
      el.removeEventListener('touchend', this.handleTouchEnd, false);
      el.removeEventListener('mousedown', this.handleTouchStart, false);
      el.removeEventListener('mousemove', this.handleTouchMove, false);
      document.removeEventListener('mouseup', this.handleTouchEnd, false);
    }
  }, {
    key: 'setCurrentFrame',
    value: function setCurrentFrame(frame) {
      var _props = this.props,
          cycle = _props.cycle,
          children = _props.children,
          onChange = _props.onChange;

      var length = children.length;
      var current = frame;
      if (current < 0) current = cycle ? current + length : 0;
      if (current > length - 1) current = cycle ? current - length : length - 1;
      if (current !== this.state.current) {
        this.setState({ current: current });
        if (typeof onChange === 'function') onChange(current);
      }
    }
  }, {
    key: 'handleWheel',
    value: function handleWheel(event) {
      event.preventDefault();
      var deltaY = event.deltaY;

      var delta = deltaY === 0 ? 0 : deltaY / Math.abs(deltaY);
      this.setCurrentFrame(this.state.current + delta);
    }
  }, {
    key: 'handleTouchStart',
    value: function handleTouchStart(event) {
      event.preventDefault();
      this.pointerPosition = this.calculatePointerPosition(event);
      this.startFrame = this.state.current;
    }
  }, {
    key: 'handleTouchMove',
    value: function handleTouchMove(event) {
      var _props2 = this.props,
          vertical = _props2.vertical,
          children = _props2.children;

      event.preventDefault();
      if (typeof this.pointerPosition !== 'number') return;

      var _findDOMNode = (0, _reactDom.findDOMNode)(this),
          offsetWidth = _findDOMNode.offsetWidth,
          offsetHeight = _findDOMNode.offsetHeight;

      var pointer = this.calculatePointerPosition(event);
      var max = vertical ? offsetHeight : offsetWidth;
      var offset = pointer - this.pointerPosition;
      var delta = Math.floor(offset / max * children.length);
      this.setCurrentFrame(this.startFrame + delta);
    }
  }, {
    key: 'handleTouchEnd',
    value: function handleTouchEnd(event) {
      event.preventDefault();
      this.pointerPosition = null;
      this.startFrame = null;
    }
  }, {
    key: 'calculatePointerPosition',
    value: function calculatePointerPosition(event) {
      var touch = event.type.indexOf('touch') === 0 ? event.changedTouches[0] : event;
      var clientX = touch.clientX,
          clientY = touch.clientY;

      var _findDOMNode2 = (0, _reactDom.findDOMNode)(this),
          offsetTop = _findDOMNode2.offsetTop,
          offsetLeft = _findDOMNode2.offsetLeft;

      return this.props.vertical ? clientY - offsetTop : clientX - offsetLeft;
    }
  }, {
    key: 'render',
    value: function render() {
      var current = this.state.current;
      var _props3 = this.props,
          children = _props3.children,
          className = _props3.className;


      return _react2.default.createElement(
        'div',
        { className: className, style: { position: 'relative' } },
        _react.Children.map(children, function (child, i) {
          return (0, _react.cloneElement)(child, { style: { width: '100%', display: current === i ? 'block' : 'none' } });
        })
      );
    }
  }]);

  return Rotation;
}(_react.Component);

Rotation.propTypes = {
  className: _react.PropTypes.string,
  cycle: _react.PropTypes.bool,
  scroll: _react.PropTypes.bool,
  vertical: _react.PropTypes.bool,
  onChange: _react.PropTypes.func,
  children: _react.PropTypes.arrayOf(_react.PropTypes.element).isRequired
};
Rotation.defaultProps = {
  cycle: false,
  scroll: true,
  vertical: false
};
exports.default = Rotation;
